package com.example.gameslistwithapi;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Base64;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

public class AdapterGame extends BaseAdapter {

    private Context mContext;

    public AdapterGame(Context mContext, List<Game> gameList) {
        this.mContext = mContext;
        this.gameList = gameList;
    }

    List<Game> gameList;

    @Override
    public int getCount() {
        return gameList.size();
    }

    @Override
    public Object getItem(int i) {
        return gameList.get(i);
    }

    @Override
    public long getItemId(int i) {
        return gameList.get(i).getId();
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View v = View.inflate(mContext, R.layout.item, null);

        TextView Name = v.findViewById(R.id.name);
        ImageView Picture = v.findViewById(R.id.picture);
        TextView Developer = v.findViewById(R.id.developer);

        Game game = gameList.get(position);
        Name.setText(game.getName());
        Picture.setImageBitmap(getGamePicture(game.getPicture()));
        Developer.setText(game.getDeveloper());

        return v;
    }

    private Bitmap getGamePicture(String encodedImg) {

        if (encodedImg != null && !encodedImg.equals("null")) {
            byte[] bytes = Base64.decode(encodedImg, Base64.DEFAULT);
            return BitmapFactory.decodeByteArray(bytes, 0, bytes.length);
        } else return null;
    }
}