package com.example.gameslistwithapi;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;

public class DeleteActivity extends AppCompatActivity {

    Button back;
    Button delete;

    Intent intentBack;

    Spinner list;

    private ArrayList<Game> rows = new ArrayList<>();
    private AdapterGame pAdapter = new AdapterGame(DeleteActivity.this, rows);

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_delete);

        back = findViewById(R.id.back);
        back.setOnClickListener(new BackClick());
        intentBack = new Intent(this, MainActivity.class);

        delete = findViewById(R.id.delete);
        delete.setOnClickListener(new DeleteClick());

        new GetGames().execute();

        list = findViewById(R.id.list);
        list.setAdapter(pAdapter);
    }

    private class GetGames extends AsyncTask<Void, Void, String> {

        @Override
        protected String doInBackground(Void... voids) {
            try {
                URL url = new URL("https://ngknn.ru:5001/ngknn/ГлодинМН/api/Games");
                HttpURLConnection connection = (HttpURLConnection) url.openConnection();

                BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                StringBuilder result = new StringBuilder();
                String line = "";

                while ((line = reader.readLine()) != null) {
                    result.append(line);
                }
                return result.toString();
            } catch (Exception exception) {
                return null;
            }
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            try {
                JSONArray tempArray = new JSONArray(s);
                for (int i = 0; i < tempArray.length(); i++) {
                    JSONObject productJson = tempArray.getJSONObject(i);
                    Game game = new Game(
                            productJson.getInt("id"),
                            productJson.getString("name"),
                            productJson.getString("picture"),
                            productJson.getString("developer")
                    );
                    rows.add(game);
                    pAdapter.notifyDataSetInvalidated();
                }
            } catch (Exception ignored) {

            }
        }
    }

    public void gameDelete() {
        Retrofit retrofit = new Retrofit.Builder()
                .baseUrl("https://ngknn.ru:5001/ngknn/ГлодинМН/api/Games/")
                .addConverterFactory(GsonConverterFactory.create())
                .build();
        RetrofitApi retrofitApi = retrofit.create(RetrofitApi.class);
        Call<Game> call = retrofitApi.deleteData(((Game) list.getSelectedItem()).getId());

        call.enqueue(new Callback<Game>() {
            @Override
            public void onResponse(Call<Game> call, Response<Game> response) {
                Toast.makeText(DeleteActivity.this, "Вы удалили запись", Toast.LENGTH_SHORT).show();
                Game responseFromAPI = response.body();
            }

            @Override
            public void onFailure(Call<Game> call, Throwable t) {

            }
        });

    }

    class BackClick implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            startActivity(intentBack);
        }
    }

    class DeleteClick implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            gameDelete();
        }
    }
}
