package com.example.gameslistwithapi;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

import androidx.appcompat.app.AppCompatActivity;

public class MainActivity extends AppCompatActivity {

    Button select;
    Button insert;
    Button update;
    Button delete;

    Intent intentSelect;
    Intent intentInsert;
    Intent intentUpdate;
    Intent intentDelete;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        select = findViewById(R.id.activity_select_button);
        select.setOnClickListener(new SelectClick());
        intentSelect = new Intent(this, SelectActivity.class);

        insert = findViewById(R.id.activity_insert_button);
        insert.setOnClickListener(new InsertClick());
        intentInsert = new Intent(this, InsertActivity.class);

        update = findViewById(R.id.activity_update_button);
        update.setOnClickListener(new UpdateClick());
        intentUpdate = new Intent(this, UpdateActivity.class);

        delete = findViewById(R.id.activity_delete_button);
        delete.setOnClickListener(new DeleteClick());
        intentDelete = new Intent(this, DeleteActivity.class);
    }

    class SelectClick implements OnClickListener {
        @Override
        public void onClick(View v) {
            startActivity(intentSelect);
        }
    }

    class InsertClick implements OnClickListener {
        @Override
        public void onClick(View v) {
            startActivity(intentInsert);
        }
    }

    class UpdateClick implements OnClickListener {
        @Override
        public void onClick(View v) {
            startActivity(intentUpdate);
        }
    }

    class DeleteClick implements OnClickListener {
        @Override
        public void onClick(View v) {
            startActivity(intentDelete);
        }
    }
}