package com.example.gameslistwithapi;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.Spinner;

import androidx.appcompat.app.AppCompatActivity;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class SelectActivity extends AppCompatActivity {

    Button back;
    Button reset;

    EditText field;

    ImageButton find;

    Intent intentBack;

    ListView list;

    Spinner order;

    String fieldText = "";

    private AdapterGame pAdapter;
    private List<Game> GamesList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_select);

        back = findViewById(R.id.back);
        back.setOnClickListener(new BackClick());
        intentBack = new Intent(this, MainActivity.class);

        reset = findViewById(R.id.reset);
        reset.setOnClickListener(new ResetClick());

        find = findViewById(R.id.find);
        find.setOnClickListener(new FindClick());

        field = findViewById(R.id.field);

        list = findViewById(R.id.list);

        order = findViewById(R.id.order);
        order.setOnItemSelectedListener(new ListSet());

        pAdapter = new AdapterGame(SelectActivity.this, GamesList);
        list.setAdapter(pAdapter);

        new GetGames().execute();
    }

    private class GetGames extends AsyncTask<Void, Void, String> {

        @Override
        protected String doInBackground(Void... voids) {
            try {
                URL url = new URL("https://ngknn.ru:5001/ngknn/ГлодинМН/api/Games");
                HttpURLConnection connection = (HttpURLConnection) url.openConnection();

                BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                StringBuilder result = new StringBuilder();
                String line = "";

                while ((line = reader.readLine()) != null) {
                    result.append(line);
                }
                return result.toString();
            } catch (Exception exception) {
                return null;
            }
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            try {
                JSONArray tempArray = new JSONArray(s);
                for (int i = 0; i < tempArray.length(); i++) {
                    JSONObject productJson = tempArray.getJSONObject(i);
                    Game game = new Game(
                            productJson.getInt("id"),
                            productJson.getString("name"),
                            productJson.getString("picture"),
                            productJson.getString("developer")
                    );
                    GamesList.add(game);
                    pAdapter.notifyDataSetInvalidated();
                }
            } catch (Exception ignored) {

            }
        }
    }

    class ResetClick implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            GamesList.clear();
            new GetGames().execute();
        }
    }

    class BackClick implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            startActivity(intentBack);
        }
    }

    class FindClick implements View.OnClickListener {
        @Override
        public void onClick(View v) {

        }
    }

    class ListSet implements AdapterView.OnItemSelectedListener {
        @Override
        public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {

        }

        @Override
        public void onNothingSelected(AdapterView<?> adapterView) {

        }
    }
}